//  PokerJan Game Programmed by Teikoku 2016

// タイマーイベント用
var g_timerID;
var g_CardMax = 48;
// カードマーク
var g_CardMark = new Array(
	"ス","ハ","ダ","ク"
);
// カード数字
var g_CardRank = new Array(
	"3","4","5","6","7","8","9","Ｘ","J","Q","K","A"
);
// 役判定用
var g_AgariYaku = new Array(
	0, 2, 3, 0, 4, 0, 0, 0, 1, 5, 0, 0, 0, 0, 0, 0, 1, 6
);
// 役の名前
var g_YakuName = new Array(
	"","ｽﾄﾚｰﾄ","ﾌﾗｯｼｭ","ﾌﾙﾊｳｽ","ﾌｫｰｶｰﾄﾞ","ｽﾄﾚｰﾄﾌﾗｯｼｭ","ﾛｲﾔﾙｽﾄﾚｰﾄﾌﾗｯｼｭ"
);
// カード使用フラグ
var g_CardUsed = new Array(g_CardMax);
// プレイヤー用手札
var g_PlayerHand = new Array(5);
// コンピュータ用手札
var g_ComHand = new Array(5);
// 役判定用手札
var g_TempHand = new Array(5);
//
var g_Turn, g_At0, g_At1, g_DropCard;

// 最初に実行する関数
function initProg() {
	g_clickable = false;
	g_button = -1;
	// トランプ用マークセット
	setChrData( 'ス', '001000011100011100111110111110001000011100000000' );	// スペード
	setChrData( 'ハ', '010100110110111110111110111110011100001000000000' );	// ハート
	setChrData( 'ダ', '001000011100111110111110111110011100001000000000' );	// ダイヤ
	setChrData( 'ク', '011100011100111110111110101010001000011100000000' );	//　クラブ
	setChrData( 'Ｘ', '100100101010101010101010101010101010100100000000' );	// 数字の10
	// サンプル
	LCDCls(0);
	gameTitle();
}

// タイトル画面
function gameTitle(){
	g_clickable = false;
	g_button = -1;
	LCDCls(0);
	LCDMsg(0,0,"POKERJAN - ﾎﾟｶｼﾞｬﾝ ｹﾞｰﾑ");
	LCDMsg(0,2,"PUSH ANY BUTTON TO START");
	LCDMsg(2,3,"Presented by Teikoku");
	//
	g_clickable = true;
	g_button = -1;
	g_timerID = setInterval( function() {
		if (g_button >= 0 && g_button <= 5) {
			g_clickable = false;
			clearInterval(g_timerID);
			gamePrepare();
		}
	} ,100);
}

// ゲーム準備
function gamePrepare() {
	LCDCls(0);
	makeHandCard();
	playerTurn();
}

// カード表示
function printCard(x, y, n){
	var m, r, s;
	s = "    ";
	if (n < 999) {
		r = parseInt(n / 10);
		m = n % 10;
		s = "["+g_CardMark[m]+g_CardRank[r]+"]";
	}
	LCDMsg(x, y, s);
}

// 役判定
function yakuHantei(){
	var i, fl, st, fc, fh, t, t2;
	// 並べ替え
	cardSort(g_TempHand);
	// フラッシュかどうか
	fl = 1;
	for (i=1;i<5;i++) {
		if ((g_TempHand[i] % 10) != (g_TempHand[0] % 10)) {
			fl = 0;
			break;
		}
	}
	// ストレートかどうか
	t = parseInt(g_TempHand[0] / 10);
	st = 1;
	for (i=1;i<5;i++) {
		if (parseInt(g_TempHand[i] / 10) != (t+i)) {
			st = 0;
			break;
		}
	}
	if ((st == 1) && (t == 3)) st = 2;
	// フォーカードかどうか
	fc = 1;
	t = parseInt(g_TempHand[1] / 10);
	if ((parseInt(g_TempHand[2] / 10) != t) || (parseInt(g_TempHand[3] / 10) != t)) {
		fc = 0;
	} else {
		if ((parseInt(g_TempHand[0] / 10) != t) && (parseInt(g_TempHand[4] / 10) != t))
		fc = 0;
	}
	// フルハウスかどうか
	fh = 1;
	t = parseInt(g_TempHand[0] / 10);
	t2 = parseInt(g_TempHand[4] / 10);
	if ((parseInt(g_TempHand[1] / 10) != t) || (parseInt(g_TempHand[3] / 10) != t2)) {
		fh = 0;
	} else {
		if ((parseInt(g_TempHand[2] / 10) != t) && (parseInt(g_TempHand[2] / 10) != t2))
		fh = 0;
	}
	// 戻り値（10始まりストレート16、その他ストレート8、フォーカード4、フルハウス2、フラッシュ1）
	// 戻り値9→ストレートフラッシュ、戻り値17→ロイヤルストレートフラッシュ
	return st*8+fc*4+fh*2+fl;
}

// 手札配布
function makeHandCard() {
	var i, r;
	for (i=0;i<g_CardMax;i++) g_CardUsed[i] = 0;
	for (i=0;i<5;i++) {
		g_PlayerHand[i] = 1000;
		g_ComHand[i] = 1000;
	}
	r = (parseInt(Math.random()*6));
	if (r==0) r=1; else r=2;
	makeHandCard2(r);
	for (i=0;i<5;i++) g_ComHand[i] = g_TempHand[i];
	cardSort(g_ComHand);
	makeHandCard2(0);
	for (i=0;i<5;i++) g_PlayerHand[i] = g_TempHand[i];
	cardSort(g_PlayerHand);
	g_Turn = 1;
	g_At0 = parseInt(Math.random()*(parseInt((g_CardMax - 12) / 4) - 3)+ 5);
	g_At1 = parseInt(Math.random()*2);
	g_DropCard = 1000;
	for (i=0;i<5;i++) printCard( i*4, 0, g_ComHand[i]);
}

//
function makeHandCard2(n) {
	var i, r, m, t;
	for (i=0;i<5;i++) g_TempHand[i] = 1000;
	// decideyaku
	switch (n) {
	case 1:
		// straight flash
		m = parseInt(Math.random()*4);
		r = parseInt(Math.random()*(parseInt(g_CardMax - 20)/4))+1;
		for (i=0;i<4;i++) {
			g_CardUsed[r*4+m+i*4] = 2;
			g_TempHand[i] = r*10+m+i*10;
		}
		g_CardUsed[r*4+m-4] = 3;
		g_CardUsed[r*4+m+16] = 3;
		break;
	case 2:
		// four of a kind or full house
		m = parseInt(Math.random()*g_CardMax);
		r = parseInt(m / 4);
		t = m % 4;
		for (i=0;i<4;i++) {
			g_CardUsed[r*4+i] = 2;
			g_TempHand[i] = r*10+i;
		}
		g_CardUsed[m] = 3;
		m = parseInt(Math.random()*g_CardMax);
		while (g_CardUsed[m] > 0) m = (m+5) % g_CardMax;
		g_CardUsed[m] = 2;
		g_TempHand[t] = parseInt(m / 4)*10+(m % 4);
		r = parseInt(m / 4);
		t = (m + parseInt(Math.random()*3)+1) % 4;
		while (g_CardUsed[r*4+t] > 0) t = (t+1) % 4;
		g_CardUsed[r*4+t] = 3;
		break;
	default:
		for (i=0;i<4;i++) {
			t = parseInt(Math.random()*g_CardMax);
			while (g_CardUsed[t] > 0) t = (t+5) % g_CardMax;
			g_CardUsed[t] = 1;
			g_TempHand[i] = parseInt(t / 4)*10+(t % 4);
		}
	}
}

// カード並べ替え
function cardSort(a) {
	a.sort(function(a,b) {
		if( a < b ) return -1;
		if( a > b ) return 1;
		return 0;
	});
}

// プレイヤーターン
function playerTurn() {
	var i, t;
	g_clickable = false;
	g_button = -1;
	// 山札からカードを取得
	if ((g_Turn == g_At0) && (g_At1 == 1)) {
		t = parseInt(Math.random()*g_CardMax);
		while (g_CardUsed[t] != 3) t = (t+1) % g_CardMax;
	} else {
		t = parseInt(Math.random()*g_CardMax);
		while (g_CardUsed[t] > 0) t = (t+5) % g_CardMax;
	}
	g_CardUsed[t] = 1;
	g_PlayerHand[4] = parseInt(t / 4)*10+(t % 4);
	for (i=0;i<5;i++) printCard( i*4, 3, g_PlayerHand[i]);
	LCDMsg(0,0,"                        ");
	LCDMsg(0,1,"YOU ﾉ ﾀｰﾝ               ");
	LCDMsg(0,2,"1-5:ｶｰﾄﾞｦｽﾃﾙ  6:ｱｶﾞﾙ    ");
	//
	g_clickable = true;
	g_button = -1;
	g_timerID = setInterval( function() {
		if (g_button >=0 && g_button <= 4) {
			g_clickable = false;
			clearInterval(g_timerID);
			playerCardDrop(g_button);
		}
		if (g_button == 5) {
			g_clickable = false;
			for (i=0;i<5;i++) g_TempHand[i] = g_PlayerHand[i];
			if (g_AgariYaku[yakuHantei()] > 0) {
				clearInterval(g_timerID);
				LCDMsg(0,1,"YOU:ﾂﾓ!                 ");
				LCDMsg(0,2,"                        ");
				gameAgari(1);
			} else {
				g_clickable = true;
				g_button = -1;
			}
		}
	} ,100);
}

// プレイヤーカード捨て処理
function playerCardDrop(n) {
	g_DropCard = g_PlayerHand[n];
	g_PlayerHand[n] = 1000;
	cardSort(g_PlayerHand);
	for (i=0;i<5;i++) printCard( i*4, 3, g_PlayerHand[i]);
	LCDMsg(0,1,"                        ");
	LCDMsg(0,2,"YOU ﾉ ｽﾃﾌﾀﾞ             ");
	printCard(12,2,g_DropCard);
	g_TimerID = setTimeout( comRonHantei, 500);
}

// コンピュータロンあがり判定
function comRonHantei() {
	var i;
	clearTimeout(g_TimerID);
	if (g_Turn <= 3) {
		g_TimerID = setTimeout( function() {
		LCDMsg(0,2,"COM ﾉ ﾀｰﾝ               ");
		comTurn() }, 500);
	} else {
		for (i=0;i<4;i++) g_TempHand[i] = g_ComHand[i];
		g_TempHand[4] = g_DropCard;
		if (g_AgariYaku[yakuHantei()] >= 2) {
			g_TimerID = setTimeout( function() {
			LCDMsg(0,1,"COM:ﾛﾝ!                 ");
			gameAgari(0) }, 500);
		} else {
			g_TimerID = setTimeout( function() {
			LCDMsg(0,2,"COM ﾉ ﾀｰﾝ               ");
			comTurn() }, 500);
		}
	}
}

// コンピュータのターン
function comTurn() {
	var i, t;
	clearTimeout(g_TimerID);
	g_clickable = false;
	// 山札からカードを取得
	if (g_Turn >= g_At0) {
		t = parseInt(Math.random()*g_CardMax);
		while (g_CardUsed[t] != 3) t = (t+1) % g_CardMax;
	} else {
		t = parseInt(Math.random()*g_CardMax);
		while (g_CardUsed[t] > 0) t = (t+5) % g_CardMax;
	}
	g_CardUsed[t] = 1;
	g_ComHand[4] = parseInt(t / 4)*10+(t % 4);
	//
	for (i=0;i<5;i++) g_TempHand[i] = g_ComHand[i];
	if (g_AgariYaku[yakuHantei()] > 2) {
		g_TimerID = setTimeout( function() {
		LCDMsg(0,1,"COM:ﾂﾓ!                 ");
		gameAgari(0) }, 1000 );
	} else {
		g_TimerID = setTimeout( function() {
		g_DropCard = g_ComHand[4];
		g_ComHand[4] = 1000;
		cardSort(g_ComHand);
		LCDMsg(0,1,"COM ﾉ ｽﾃﾌﾀﾞ             ");
		LCDMsg(0,2,"5:ｶｰﾄﾞｦﾋｸ  6:ﾛﾝ         ");
		printCard(12,1,g_DropCard);
		playerRonHantei() }, 1000 );
	}
}

// プレイヤーﾛﾝ判定
function playerRonHantei() {
	clearTimeout(g_TimerID);
	g_clickable = true;
	g_button = -1;
	g_timerID = setInterval( function() {
		if (g_button == 4) {
			g_clickable = false;
			clearInterval(g_timerID);
			g_Turn++;
			playerTurn();
		}
		if (g_button == 5) {
			g_clickable = false;
			for (i=0;i<4;i++) g_TempHand[i] = g_PlayerHand[i];
			g_TempHand[4] = g_DropCard ;
			if (g_AgariYaku[yakuHantei()] > 0) {
				clearInterval(g_timerID);
				LCDMsg(0,1,"YOU:ﾛﾝ!                 ");
				LCDMsg(0,2,"                        ");
				gameAgari(1);
			} else {
				g_clickable = true;
				g_button = -1;
			}
		}
	} ,100);
}

// あがり処理
function gameAgari(n) {
	var i;
	clearTimeout(g_TimerID);
	for (i=0;i<5;i++) printCard(i*4,n*3,g_TempHand[i]);
	LCDMsg(8,1,g_YakuName[g_AgariYaku[yakuHantei()]]+"!");
	LCDMsg(0,2,"ﾎﾞﾀﾝｦ ｵｽﾄ ﾀｲﾄﾙﾆ ﾓﾄﾞﾘﾏｽ  ");
	//
	g_clickable = true;
	g_button = -1;
	g_timerID = setInterval( function() {
		if (g_button >= 0 && g_button <= 5) {
			g_clickable = false;
			clearInterval(g_timerID);
			gameTitle();
		}
	} ,100);
}
